TinyURL (empty) → 0.1.0
raw patch · 36 files changed
+560/−0 lines, 36 filesdep +HTTPdep +basedep +networksetup-changedbinary-added
Dependencies added: HTTP, base, network
Files
- .git/COMMIT_EDITMSG +20/−0
- .git/HEAD +1/−0
- .git/config +5/−0
- .git/description +1/−0
- .git/hooks/applypatch-msg +15/−0
- .git/hooks/commit-msg +24/−0
- .git/hooks/post-commit +8/−0
- .git/hooks/post-receive +16/−0
- .git/hooks/post-update +8/−0
- .git/hooks/pre-applypatch +14/−0
- .git/hooks/pre-commit +70/−0
- .git/hooks/pre-rebase +150/−0
- .git/hooks/prepare-commit-msg +36/−0
- .git/hooks/update +107/−0
- .git/index binary
- .git/info/exclude +6/−0
- .git/logs/HEAD +2/−0
- .git/logs/refs/heads/master +2/−0
- .git/objects/39/e8671ea0fd40f36cb633a7b81bb94f5d765c73 binary
- .git/objects/43/cda75eb86d5f0fcc3f32019356cbce1124f650 binary
- .git/objects/56/e64ab4d2f52e3acaa405b5248cece308797ac2 binary
- .git/objects/5b/de0de962274e26328ecffabb4e9f6430a10cc9 binary
- .git/objects/6f/eef8a19f8a76e01fe904d0807fbfc4ee5b70b0 binary
- .git/objects/8a/534ae463f28e10ef35b5f1559a0e7c41be86b5 binary
- .git/objects/8c/33a28cba12878383d53a524dd7fbccc617d4f5 binary
- .git/objects/9a/54144ab29167761ec1db360238dd0667c2f9e0 binary
- .git/objects/a2/61f291755404ef0ada9e519a6bf80c8172d305 binary
- .git/objects/a3/29168a2cb4a1d8b418cf2828bcbdac056df2a2 binary
- .git/objects/b5/6043fd84d44d74e63663587b8bc50373c98d38 +2/−0
- .git/objects/dc/21d20ff8e8f894787f8399a05a6bc0ffee333f binary
- .git/refs/heads/master +1/−0
- .gitignore +1/−0
- LICENSE +30/−0
- Network/TinyURL.hs +22/−0
- Setup.lhs +3/−0
- TinyURL.cabal +16/−0
+ .git/COMMIT_EDITMSG view
@@ -0,0 +1,20 @@+Initial version++# Please enter the commit message for your changes.+# (Comment lines starting with '#' will not be included)+#+# Committer: Reid Barton <rwbarton@alum.mit.edu>+#+# On branch master+#+# Initial commit+#+# Changes to be committed:+# (use "git rm --cached <file>..." to unstage)+#+# new file: .gitignore+# new file: LICENSE+# new file: Network/TinyURL.hs+# new file: Setup.lhs+# new file: TinyURL.cabal+#
+ .git/HEAD view
@@ -0,0 +1,1 @@+ref: refs/heads/master
+ .git/config view
@@ -0,0 +1,5 @@+[core]+ repositoryformatversion = 0+ filemode = true+ bare = false+ logallrefupdates = true
+ .git/description view
@@ -0,0 +1,1 @@+Unnamed repository; edit this file to name it for gitweb.
+ .git/hooks/applypatch-msg view
@@ -0,0 +1,15 @@+#!/bin/sh+#+# An example hook script to check the commit log message taken by+# applypatch from an e-mail message.+#+# The hook should exit with non-zero status after issuing an+# appropriate message if it wants to stop the commit. The hook is+# allowed to edit the commit message file.+#+# To enable this hook, make this file executable.++. git-sh-setup+test -x "$GIT_DIR/hooks/commit-msg" &&+ exec "$GIT_DIR/hooks/commit-msg" ${1+"$@"}+:
+ .git/hooks/commit-msg view
@@ -0,0 +1,24 @@+#!/bin/sh+#+# An example hook script to check the commit log message.+# Called by git-commit with one argument, the name of the file+# that has the commit message. The hook should exit with non-zero+# status after issuing an appropriate message if it wants to stop the+# commit. The hook is allowed to edit the commit message file.+#+# To enable this hook, make this file executable.++# Uncomment the below to add a Signed-off-by line to the message.+# Doing this in a hook is a bad idea in general, but the prepare-commit-msg+# hook is more suited to it.+#+# SOB=$(git var GIT_AUTHOR_IDENT | sed -n 's/^\(.*>\).*$/Signed-off-by: \1/p')+# grep -qs "^$SOB" "$1" || echo "$SOB" >> "$1"++# This example catches duplicate Signed-off-by lines.++test "" = "$(grep '^Signed-off-by: ' "$1" |+ sort | uniq -c | sed -e '/^[ ]*1[ ]/d')" || {+ echo >&2 Duplicate Signed-off-by lines.+ exit 1+}
+ .git/hooks/post-commit view
@@ -0,0 +1,8 @@+#!/bin/sh+#+# An example hook script that is called after a successful+# commit is made.+#+# To enable this hook, make this file executable.++: Nothing
+ .git/hooks/post-receive view
@@ -0,0 +1,16 @@+#!/bin/sh+#+# An example hook script for the post-receive event+#+# This script is run after receive-pack has accepted a pack and the+# repository has been updated. It is passed arguments in through stdin+# in the form+# <oldrev> <newrev> <refname>+# For example:+# aa453216d1b3e49e7f6f98441fa56946ddcd6a20 68f7abf4e6f922807889f52bc043ecd31b79f814 refs/heads/master+#+# see contrib/hooks/ for an sample, or uncomment the next line (on debian)+#+++#. /usr/share/doc/git-core/contrib/hooks/post-receive-email
+ .git/hooks/post-update view
@@ -0,0 +1,8 @@+#!/bin/sh+#+# An example hook script to prepare a packed repository for use over+# dumb transports.+#+# To enable this hook, make this file executable by "chmod +x post-update".++exec git-update-server-info
+ .git/hooks/pre-applypatch view
@@ -0,0 +1,14 @@+#!/bin/sh+#+# An example hook script to verify what is about to be committed+# by applypatch from an e-mail message.+#+# The hook should exit with non-zero status after issuing an+# appropriate message if it wants to stop the commit.+#+# To enable this hook, make this file executable.++. git-sh-setup+test -x "$GIT_DIR/hooks/pre-commit" &&+ exec "$GIT_DIR/hooks/pre-commit" ${1+"$@"}+:
+ .git/hooks/pre-commit view
@@ -0,0 +1,70 @@+#!/bin/sh+#+# An example hook script to verify what is about to be committed.+# Called by git-commit with no arguments. The hook should+# exit with non-zero status after issuing an appropriate message if+# it wants to stop the commit.+#+# To enable this hook, make this file executable.++# This is slightly modified from Andrew Morton's Perfect Patch.+# Lines you introduce should not have trailing whitespace.+# Also check for an indentation that has SP before a TAB.++if git-rev-parse --verify HEAD 2>/dev/null+then+ git-diff-index -p -M --cached HEAD --+else+ # NEEDSWORK: we should produce a diff with an empty tree here+ # if we want to do the same verification for the initial import.+ :+fi |+perl -e '+ my $found_bad = 0;+ my $filename;+ my $reported_filename = "";+ my $lineno;+ sub bad_line {+ my ($why, $line) = @_;+ if (!$found_bad) {+ print STDERR "*\n";+ print STDERR "* You have some suspicious patch lines:\n";+ print STDERR "*\n";+ $found_bad = 1;+ }+ if ($reported_filename ne $filename) {+ print STDERR "* In $filename\n";+ $reported_filename = $filename;+ }+ print STDERR "* $why (line $lineno)\n";+ print STDERR "$filename:$lineno:$line\n";+ }+ while (<>) {+ if (m|^diff --git a/(.*) b/\1$|) {+ $filename = $1;+ next;+ }+ if (/^@@ -\S+ \+(\d+)/) {+ $lineno = $1 - 1;+ next;+ }+ if (/^ /) {+ $lineno++;+ next;+ }+ if (s/^\+//) {+ $lineno++;+ chomp;+ if (/\s$/) {+ bad_line("trailing whitespace", $_);+ }+ if (/^\s* \t/) {+ bad_line("indent SP followed by a TAB", $_);+ }+ if (/^([<>])\1{6} |^={7}$/) {+ bad_line("unresolved merge conflict", $_);+ }+ }+ }+ exit($found_bad);+'
+ .git/hooks/pre-rebase view
@@ -0,0 +1,150 @@+#!/bin/sh+#+# Copyright (c) 2006 Junio C Hamano+#++publish=next+basebranch="$1"+if test "$#" = 2+then+ topic="refs/heads/$2"+else+ topic=`git symbolic-ref HEAD`+fi++case "$basebranch,$topic" in+master,refs/heads/??/*)+ ;;+*)+ exit 0 ;# we do not interrupt others.+ ;;+esac++# Now we are dealing with a topic branch being rebased+# on top of master. Is it OK to rebase it?++# Is topic fully merged to master?+not_in_master=`git-rev-list --pretty=oneline ^master "$topic"`+if test -z "$not_in_master"+then+ echo >&2 "$topic is fully merged to master; better remove it."+ exit 1 ;# we could allow it, but there is no point.+fi++# Is topic ever merged to next? If so you should not be rebasing it.+only_next_1=`git-rev-list ^master "^$topic" ${publish} | sort`+only_next_2=`git-rev-list ^master ${publish} | sort`+if test "$only_next_1" = "$only_next_2"+then+ not_in_topic=`git-rev-list "^$topic" master`+ if test -z "$not_in_topic"+ then+ echo >&2 "$topic is already up-to-date with master"+ exit 1 ;# we could allow it, but there is no point.+ else+ exit 0+ fi+else+ not_in_next=`git-rev-list --pretty=oneline ^${publish} "$topic"`+ perl -e '+ my $topic = $ARGV[0];+ my $msg = "* $topic has commits already merged to public branch:\n";+ my (%not_in_next) = map {+ /^([0-9a-f]+) /;+ ($1 => 1);+ } split(/\n/, $ARGV[1]);+ for my $elem (map {+ /^([0-9a-f]+) (.*)$/;+ [$1 => $2];+ } split(/\n/, $ARGV[2])) {+ if (!exists $not_in_next{$elem->[0]}) {+ if ($msg) {+ print STDERR $msg;+ undef $msg;+ }+ print STDERR " $elem->[1]\n";+ }+ }+ ' "$topic" "$not_in_next" "$not_in_master"+ exit 1+fi++exit 0++################################################################++This sample hook safeguards topic branches that have been+published from being rewound.++The workflow assumed here is:++ * Once a topic branch forks from "master", "master" is never+ merged into it again (either directly or indirectly).++ * Once a topic branch is fully cooked and merged into "master",+ it is deleted. If you need to build on top of it to correct+ earlier mistakes, a new topic branch is created by forking at+ the tip of the "master". This is not strictly necessary, but+ it makes it easier to keep your history simple.++ * Whenever you need to test or publish your changes to topic+ branches, merge them into "next" branch.++The script, being an example, hardcodes the publish branch name+to be "next", but it is trivial to make it configurable via+$GIT_DIR/config mechanism.++With this workflow, you would want to know:++(1) ... if a topic branch has ever been merged to "next". Young+ topic branches can have stupid mistakes you would rather+ clean up before publishing, and things that have not been+ merged into other branches can be easily rebased without+ affecting other people. But once it is published, you would+ not want to rewind it.++(2) ... if a topic branch has been fully merged to "master".+ Then you can delete it. More importantly, you should not+ build on top of it -- other people may already want to+ change things related to the topic as patches against your+ "master", so if you need further changes, it is better to+ fork the topic (perhaps with the same name) afresh from the+ tip of "master".++Let's look at this example:++ o---o---o---o---o---o---o---o---o---o "next"+ / / / /+ / a---a---b A / /+ / / / /+ / / c---c---c---c B /+ / / / \ /+ / / / b---b C \ /+ / / / / \ /+ ---o---o---o---o---o---o---o---o---o---o---o "master"+++A, B and C are topic branches.++ * A has one fix since it was merged up to "next".++ * B has finished. It has been fully merged up to "master" and "next",+ and is ready to be deleted.++ * C has not merged to "next" at all.++We would want to allow C to be rebased, refuse A, and encourage+B to be deleted.++To compute (1):++ git-rev-list ^master ^topic next+ git-rev-list ^master next++ if these match, topic has not merged in next at all.++To compute (2):++ git-rev-list master..topic++ if this is empty, it is fully merged to "master".
+ .git/hooks/prepare-commit-msg view
@@ -0,0 +1,36 @@+#!/bin/sh+#+# An example hook script to prepare the commit log message.+# Called by git-commit with the name of the file that has the+# commit message, followed by the description of the commit+# message's source. The hook's purpose is to edit the commit+# message file. If the hook fails with a non-zero status,+# the commit is aborted.+#+# To enable this hook, make this file executable.++# This hook includes three examples. The first comments out the+# "Conflicts:" part of a merge commit.+#+# The second includes the output of "git diff --name-status -r"+# into the message, just before the "git status" output. It is+# commented because it doesn't cope with --amend or with squashed+# commits.+#+# The third example adds a Signed-off-by line to the message, that can+# still be edited. This is rarely a good idea.++case "$2,$3" in+ merge,)+ perl -i -ne 's/^/# /, s/^# #/#/ if /^Conflicts/ .. /#/; print' "$1" ;;++# ,|template,)+# perl -i -pe '+# print "\n" . `git diff --cached --name-status -r`+# if /^#/ && $first++ == 0' "$1" ;;++ *) ;;+esac++# SOB=$(git var GIT_AUTHOR_IDENT | sed -n 's/^\(.*>\).*$/Signed-off-by: \1/p')+# grep -qs "^$SOB" "$1" || echo "$SOB" >> "$1"
+ .git/hooks/update view
@@ -0,0 +1,107 @@+#!/bin/sh+#+# An example hook script to blocks unannotated tags from entering.+# Called by git-receive-pack with arguments: refname sha1-old sha1-new+#+# To enable this hook, make this file executable by "chmod +x update".+#+# Config+# ------+# hooks.allowunannotated+# This boolean sets whether unannotated tags will be allowed into the+# repository. By default they won't be.+# hooks.allowdeletetag+# This boolean sets whether deleting tags will be allowed in the+# repository. By default they won't be.+# hooks.allowdeletebranch+# This boolean sets whether deleting branches will be allowed in the+# repository. By default they won't be.+#++# --- Command line+refname="$1"+oldrev="$2"+newrev="$3"++# --- Safety check+if [ -z "$GIT_DIR" ]; then+ echo "Don't run this script from the command line." >&2+ echo " (if you want, you could supply GIT_DIR then run" >&2+ echo " $0 <ref> <oldrev> <newrev>)" >&2+ exit 1+fi++if [ -z "$refname" -o -z "$oldrev" -o -z "$newrev" ]; then+ echo "Usage: $0 <ref> <oldrev> <newrev>" >&2+ exit 1+fi++# --- Config+allowunannotated=$(git config --bool hooks.allowunannotated)+allowdeletebranch=$(git config --bool hooks.allowdeletebranch)+allowdeletetag=$(git config --bool hooks.allowdeletetag)++# check for no description+projectdesc=$(sed -e '1q' "$GIT_DIR/description")+if [ -z "$projectdesc" -o "$projectdesc" = "Unnamed repository; edit this file to name it for gitweb." ]; then+ echo "*** Project description file hasn't been set" >&2+ exit 1+fi++# --- Check types+# if $newrev is 0000...0000, it's a commit to delete a ref.+if [ "$newrev" = "0000000000000000000000000000000000000000" ]; then+ newrev_type=delete+else+ newrev_type=$(git-cat-file -t $newrev)+fi++case "$refname","$newrev_type" in+ refs/tags/*,commit)+ # un-annotated tag+ short_refname=${refname##refs/tags/}+ if [ "$allowunannotated" != "true" ]; then+ echo "*** The un-annotated tag, $short_refname, is not allowed in this repository" >&2+ echo "*** Use 'git tag [ -a | -s ]' for tags you want to propagate." >&2+ exit 1+ fi+ ;;+ refs/tags/*,delete)+ # delete tag+ if [ "$allowdeletetag" != "true" ]; then+ echo "*** Deleting a tag is not allowed in this repository" >&2+ exit 1+ fi+ ;;+ refs/tags/*,tag)+ # annotated tag+ ;;+ refs/heads/*,commit)+ # branch+ ;;+ refs/heads/*,delete)+ # delete branch+ if [ "$allowdeletebranch" != "true" ]; then+ echo "*** Deleting a branch is not allowed in this repository" >&2+ exit 1+ fi+ ;;+ refs/remotes/*,commit)+ # tracking branch+ ;;+ refs/remotes/*,delete)+ # delete tracking branch+ if [ "$allowdeletebranch" != "true" ]; then+ echo "*** Deleting a tracking branch is not allowed in this repository" >&2+ exit 1+ fi+ ;;+ *)+ # Anything else (is there anything else?)+ echo "*** Update hook: unknown type of update to ref $refname of type $newrev_type" >&2+ exit 1+ ;;+esac++# --- Finished+exit 0
+ .git/index view
binary file changed (absent → 424 bytes)
+ .git/info/exclude view
@@ -0,0 +1,6 @@+# git-ls-files --others --exclude-from=.git/info/exclude+# Lines that start with '#' are comments.+# For a project mostly in C, the following would be a good set of+# exclude patterns (uncomment them if you want to use them):+# *.[oa]+# *~
+ .git/logs/HEAD view
@@ -0,0 +1,2 @@+0000000000000000000000000000000000000000 39e8671ea0fd40f36cb633a7b81bb94f5d765c73 Reid Barton <rwbarton@alum.mit.edu> 1234812419 -0500 commit (initial): Initial version+39e8671ea0fd40f36cb633a7b81bb94f5d765c73 6feef8a19f8a76e01fe904d0807fbfc4ee5b70b0 Reid Barton <rwbarton@alum.mit.edu> 1234813011 -0500 commit (amend): Initial version
+ .git/logs/refs/heads/master view
@@ -0,0 +1,2 @@+0000000000000000000000000000000000000000 39e8671ea0fd40f36cb633a7b81bb94f5d765c73 Reid Barton <rwbarton@alum.mit.edu> 1234812419 -0500 commit (initial): Initial version+39e8671ea0fd40f36cb633a7b81bb94f5d765c73 6feef8a19f8a76e01fe904d0807fbfc4ee5b70b0 Reid Barton <rwbarton@alum.mit.edu> 1234813011 -0500 commit (amend): Initial version
+ .git/objects/39/e8671ea0fd40f36cb633a7b81bb94f5d765c73 view
binary file changed (absent → 134 bytes)
+ .git/objects/43/cda75eb86d5f0fcc3f32019356cbce1124f650 view
binary file changed (absent → 55 bytes)
+ .git/objects/56/e64ab4d2f52e3acaa405b5248cece308797ac2 view
binary file changed (absent → 190 bytes)
+ .git/objects/5b/de0de962274e26328ecffabb4e9f6430a10cc9 view
binary file changed (absent → 88 bytes)
+ .git/objects/6f/eef8a19f8a76e01fe904d0807fbfc4ee5b70b0 view
binary file changed (absent → 140 bytes)
+ .git/objects/8a/534ae463f28e10ef35b5f1559a0e7c41be86b5 view
binary file changed (absent → 422 bytes)
+ .git/objects/8c/33a28cba12878383d53a524dd7fbccc617d4f5 view
binary file changed (absent → 289 bytes)
+ .git/objects/9a/54144ab29167761ec1db360238dd0667c2f9e0 view
binary file changed (absent → 806 bytes)
+ .git/objects/a2/61f291755404ef0ada9e519a6bf80c8172d305 view
binary file changed (absent → 22 bytes)
+ .git/objects/a3/29168a2cb4a1d8b418cf2828bcbdac056df2a2 view
binary file changed (absent → 454 bytes)
+ .git/objects/b5/6043fd84d44d74e63663587b8bc50373c98d38 view
@@ -0,0 +1,2 @@+x=ÁjÃ0D{¾b? 6=Z¨\Sb'=KÑÒÈZ!Ù´úû.¤éqfgx³Ú꡺ëÕµ£õùxèä c²äk±.7åZnV®ø7aSV²Y¬3Å7;²³gôu3ìîoªØ[ÇV÷ºmû¡ÏËüEa´gòLñb®Åj9dO!ÙTcBø3Á¦1%àI2@G³¸nÙa@o¸¦U¼ãû+<Îß/j%4ÅÅ!Çú멼½ý®ýV°
+ .git/objects/dc/21d20ff8e8f894787f8399a05a6bc0ffee333f view
binary file changed (absent → 191 bytes)
+ .git/refs/heads/master view
@@ -0,0 +1,1 @@+6feef8a19f8a76e01fe904d0807fbfc4ee5b70b0
+ .gitignore view
@@ -0,0 +1,1 @@+dist/*
+ LICENSE view
@@ -0,0 +1,30 @@+Copyright (c) 2009 Reid Barton++All rights reserved.++Redistribution and use in source and binary forms, with or without+modification, are permitted provided that the following conditions+are met:++1. Redistributions of source code must retain the above copyright+ notice, this list of conditions and the following disclaimer.++2. Redistributions in binary form must reproduce the above copyright+ notice, this list of conditions and the following disclaimer in the+ documentation and/or other materials provided with the distribution.++3. Neither the name of the author nor the names of his contributors+ may be used to endorse or promote products derived from this software+ without specific prior written permission.++THIS SOFTWARE IS PROVIDED BY THE AUTHORS ``AS IS'' AND ANY EXPRESS OR+IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED+WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE+DISCLAIMED. IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE LIABLE FOR+ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL+DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS+OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)+HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,+STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN+ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE+POSSIBILITY OF SUCH DAMAGE.
+ Network/TinyURL.hs view
@@ -0,0 +1,22 @@+module Network.TinyURL (tinyURL) where++import Network.HTTP+import Network.URI++-- | Use TinyURL to compress a URL. In the event of a failure, return+-- the original URL.+tinyURL :: String -> IO String+tinyURL url = do+ result <- simpleHTTP request `catch` (const . return $ Left undefined)+ case result of+ Left _ -> return url+ Right response -> return $ rspBody response+ where request = Request { rqURI = uri+ , rqMethod = GET+ , rqHeaders = []+ , rqBody = "" }+ uri = URI { uriScheme = "http:"+ , uriAuthority = Just $ URIAuth { uriUserInfo = "", uriRegName = "tinyurl.com", uriPort = "" }+ , uriPath = "/api-create.php"+ , uriQuery = "?url=" ++ escapeURIString isUnreserved url+ , uriFragment = "" }
+ Setup.lhs view
@@ -0,0 +1,3 @@+#!/usr/bin/env runhaskell+> import Distribution.Simple+> main = defaultMain
+ TinyURL.cabal view
@@ -0,0 +1,16 @@+Name: TinyURL+Version: 0.1.0+Cabal-Version: >= 1.2+Build-Type: Simple+License: BSD3+License-File: LICENSE+Author: Reid Barton+Maintainer: Reid Barton+Category: Web+Synopsis: Use TinyURL to compress URLs+Description: This package exports a single function that uses+ the TinyURL API to compress a given URL.++Library+ Build-Depends: base, HTTP, network+ Exposed-Modules: Network.TinyURL